program Can;

{$APPTYPE CONSOLE}

// dologin.can cancrm.can you.can dbtest.txt customer.can newemployee.can
// orderdetails.can
// redirect.txt getimage.can employee.can
// canbdeadmin.can orders.can dologout.can
uses
  SysUtils,
  Classes,
  Variants,
  UrlMon,
  Windows,
  TreeList in 'TreeList.pas',
  ScriptParser in 'ScriptParser.pas',
  ScriptVariants in 'ScriptVariants.pas',
  ScriptFuncs in 'ScriptFuncs.pas',
  EvalExpr in 'EvalExpr.pas',
  Interprt in 'Interprt.pas',
  DbFuncs in 'DbFuncs.pas',
  Execution in 'Execution.pas',
  SysObjList in 'SysObjList.pas',
  SysUnit in 'SysUnit.pas',
  CanApp in 'CanApp.pas',
  Sessions in 'Sessions.pas',
  StringUtils in 'StringUtils.pas';

function Execute: TStrings;
var
  Strings: TStringList;
  Value: string;
  Environment, Data, Save: PChar;
begin
  Strings := TStringList.Create;
  Result := Strings;
  try
    Environment := GetEnvironmentStrings();
    try
      Data := Environment;
      while Data^ <> #0 do begin
        Save := Data;
        while Data^ <> #0 do Inc(Data);
        SetString(Value, Save, Data - Save);
        Inc(Data);
        if Data^ = #0 then Break;
        if Value <> '' then Strings.Add(Value);
      end;
    finally
      FreeEnvironmentStrings(Environment);
    end;
  except
    Strings.Free;
  end;
end;

{
var
  I: Integer;
  URL: WideString;
  szResult: array[0..1023] of WideChar;
  ccResult: Cardinal;
  Result: HRESULT;
}
{
var
  Strings: TStrings;
  Index: Integer;
}
begin
  {
  Strings := Execute;
  for Index := 0 to Strings.Count - 1 do
    WriteLn(Strings.Names[Index]);
  FreeAndNil(Strings);
  ReadLn;
  }
  {
  I := 0;
  repeat
    WriteLn( I );
    I := I + 1;
  until I > 5;
  }

  Application := TCanCGIApplication.Create;
  try
    Application.Run;
  finally
    Application.Free;
  end;
  
  {
  URL := 'http://winxp/cancrm/dologin.can';
  FillChar( szResult, SizeOf(szResult), 0 );
  Result := CoInternetParseUrl(PWideChar(URL), PARSE_ROOTDOCUMENT, 0, szResult,
    SizeOf(szResult), ccResult, 0 );
  if Result = S_OK then
    WriteLn(szResult)
  else if Result = INET_E_DEFAULT_ACTION then
    WriteLn('INET_E_DEFAULT_ACTION')
  else
    WriteLn('S_FALSE');
  ReadLn;
  }
end.
